<?php

/*
Plugin Name: PS banner with date Widget
Plugin URI: http://div3-demo.prime-strategy.co.jp/ps-banner-with-date-widget/
Description: 20140220に行われたセミナーのデモのために作成されたプライグインです。ウィジェトに「PS-バナー（日付制限あり）」を追加します。
Version: 0.0.1
Author: PRIME STRATEGY CO.,LTD. DIV3 TEAM
Author URI: http://div3-demo.prime-strategy.co.jp/
License: GPL2
*/

/*  Copyright 2014 PRIME STRATEGY CO.,LTD. DIV3 TEAM (email : div3@prime-strategy.co.jp)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as
	published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

class PS_banner_with_date_Widget extends WP_Widget {

	function PS_banner_with_date_Widget() {
		$widget_opts	= array( 'classname' 	=> 'ps_banner_with_date_widget', 
								 'description'	=> 'URL・画像の情報からバナーを生成するウィジェットです。日付制限も可能です。' 
								);
		$control_opts	= array( 'width'  => 300, 
								 'height' => 350
								);
		$this->WP_Widget( 'psbannerwithdate', 'PS-バナー（日付制限あり）', $widget_opts, $control_opts );
	}

	//登録内容の表示
	function widget( $args, $instance ) {

		extract($args);
			$testmode	= isset( $instance['testmode'] ) ? (bool) $instance['testmode']   : false;
			$title 		= isset( $instance['title'] )    ? esc_html( $instance['title'] ) : false;
			$url 		= isset( $instance['url'] )      ? esc_url( $instance['url'] )    : false;
			$img 		= isset( $instance['img'] )      ? esc_attr( $instance['img'] )   : false;
			$alt 		= isset( $instance['alt'] )      ? esc_attr( $instance['alt'] )   : false;
			$blank 		= isset( $instance['blank'] )    ? (int) $instance['blank']       : false; 
			$top 		= isset( $instance['top'] )      ? (int) $instance['top']         : false;
			$bottom 	= isset( $instance['bottom'] )   ? (int) $instance['bottom']      : false;
			$memo 		= isset( $instance['memo'] )     ? esc_html( $instance['memo'] )  : false;			
			$start 		= isset( $instance['start'] )    ? $instance['start']             : false;
			$end 		= isset( $instance['end'] )      ? $instance['end']               : false;
			$class 		= isset( $instance['class'] )    ? esc_attr( $instance['class'] ) : false;

			$cont = '';
			$cont .=  '<div class="' . $class . '" style="margin-top:' . $top . 'px; margin-bottom:' . $bottom . 'px; text-align:center;">';
			$cont .=  '<a href="' . $url . '"';
			if ($blank == 'on') { $cont .= ' target="_blank" ';}
			$cont .=  '>';
			$cont .=  '<img src="' . $img . '" alt="' . $alt . '" />';
			$cont .=  '</a>';
			$cont .=  '</div>' . PHP_EOL;

			$today = date_i18n('Y-m-d');

			$display = 0 ;

			if ( strtotime( $start ) <= strtotime( $today ) && strtotime( $end ) >= strtotime( $today ) ) { 
				$display = 1 ; 
			} elseif ( $start == '' && strtotime( $end ) >= strtotime( $today ) ) {
				$display = 1 ; 
			} elseif ( strtotime( $start ) <= strtotime( $today ) && $end == '' ) {
				$display = 1 ; 
			} elseif ( $start == '' && $end == '' ) {
				$display = 1 ; 
			} 

			if ( $testmode ) {
				if(is_user_logged_in()) { 
					if ($display) { echo $cont; } 
				}
			} else {
				if ($display) { echo $cont; } 
			}
			//echo $display.'/'.$testmode;
	}

	//管理画面入力フォーム
	function form( $instance ) {
		$title    = isset( $instance['title'] )    ? esc_html( $instance['title'] ) : false;
		$url      = isset( $instance['url'] )      ? esc_url( $instance['url'] )    : false;
		$img      = isset( $instance['img'] )      ? esc_attr( $instance['img'] )   : false;
		$alt      = isset( $instance['alt'] )      ? esc_attr( $instance['alt'] )   : false;
		$blank    = isset( $instance['blank'] )    ? (int) $instance['blank']       : false; 
		$top      = isset( $instance['top'] )      ? (int) $instance['top']         : false;
		$bottom   = isset( $instance['bottom'] )   ? (int) $instance['bottom']      : false;
		$memo     = isset( $instance['memo'] )     ? esc_html( $instance['memo'] )  : false;
		$testmode = isset( $instance['testmode'] ) ? (bool) $instance['testmode']   : false;
		$start    = isset( $instance['start'] )    ? $instance['start']             : false;
		$end      = isset( $instance['end'] )      ? $instance['end']               : false;
		$class    = isset( $instance['class'] )    ? esc_attr( $instance['class'] ) : false;

		echo '<p><label for="' . $this->get_field_id('title') . '"> Title: </label>' . PHP_EOL;
		echo '<input class="widefat" id="' . $this->get_field_id('title') . '" name="' . $this->get_field_name('title') . '" type="text" value="' . $title . '" /></p>' . PHP_EOL;

		echo '<p><label for="' . $this->get_field_id('alt') . '"> Alt: </label>' . PHP_EOL;
		echo '<input class="widefat" id="' . $this->get_field_id('alt') . '" name="' . $this->get_field_name('alt') . '" type="text" value="' . $alt . '" /></p>' . PHP_EOL;

		echo '<p><label for="' . $this->get_field_id('url') . '"> URL: </label>' . PHP_EOL;
		echo '<input class="widefat" id="' . $this->get_field_id('url') . '" name="' . $this->get_field_name('url') . '" type="text" value="' . $url . '" /></p>' . PHP_EOL;

		echo '<p><label for="'. $this->get_field_id('img') . '"> IMG: </label>' . PHP_EOL;
		echo '<input class="widefat" id="' . $this->get_field_id('img') . '" name="' . $this->get_field_name('img') . '" type="text" value="' . $img . '" /></p>' . PHP_EOL;

		echo '<p><label for="' . $this->get_field_id('class') . '"> Class: </label>'. PHP_EOL;
		echo '<input class="widefat" id="' . $this->get_field_id('class') . '" name="' . $this->get_field_name('class') . '" type="text" value="' . $class . '" /></p>' . PHP_EOL;

		echo '<p><label for="' . $this->get_field_id('blank') . '"> _blank: </label>'. PHP_EOL;
		echo '<input class="widefat" id="' . $this->get_field_id('blank') . '" name="' . $this->get_field_name('blank') . '" type="checkbox" value="on" ';
		if( $blank == "on" ){ echo 'checked'; }
		echo '/></p>' . PHP_EOL;

		echo '<p><label for="' . $this->get_field_id('top') . '"> 上空き（単位 px）: </label>'. PHP_EOL;
		echo '<input class="widefat" id="' . $this->get_field_id('top') . '" name="'. $this->get_field_name('top') . '" type="text" value="';
		if( $top == '' ){ echo '0'; } else { echo $top; }
		echo '" /></p>' . PHP_EOL;

		echo '<p><label for="' . $this->get_field_id('bottom') . '"> 下空き（単位 px）: </label>'. PHP_EOL;
		echo '<input class="widefat" id="' . $this->get_field_id('bottom') . '" name="' . $this->get_field_name('bottom') . '" type="text" value="';
		if( $bottom == '' ){ echo '0'; }else{ echo $bottom; }
		echo '" /></p>' . PHP_EOL;

		echo '<p><label for="' . $this->get_field_id('start') . '"> 掲載開始日: </label>'. PHP_EOL;
		echo '<input class="widefat" id="' . $this->get_field_id('start') . '" name="' . $this->get_field_name('start') . '" type="date" value="';
		if( $start == '' ){ echo ''; }else{ echo $start; }
		echo '" /></p>' . PHP_EOL;

		echo '<p><label for="' . $this->get_field_id('end') . '"> 掲載終了日: </label>'. PHP_EOL;
		echo '<input class="widefat" id="' . $this->get_field_id('end') . '" name="' . $this->get_field_name('end') . '" type="date" value="';
		if( $end == '' ){ echo ''; }else{ echo esc_attr($end); }
		echo '" /></p>' . PHP_EOL;

		if ( $end ) {
			if ( strtotime( $start ) > strtotime( $end )) {
				echo '<p style="color:#FFF;background-color:#FE8497;padding:5px;text-align:center;font-weight:bold;">掲載終了日が掲載開始日より前になっています！</p>' . PHP_EOL;
			}
		}


		echo '<p><label for="' . $this->get_field_id('memo') . '"> Memo: </label>'. PHP_EOL;
		echo '<input class="widefat" id="' . $this->get_field_id('memo') . '" name="' . $this->get_field_name('memo') . '" type="text" value="' . $memo . '" /></p>'. PHP_EOL;

		echo '<p><input type="checkbox" class="checkbox" id="' . $this->get_field_id('testmode') . '" name="' . $this->get_field_name('testmode') . '" ';
		checked( $testmode );
		echo ' />';
		echo '<label for="' . $this->get_field_id('testmode') . '"> テストモード（ログイン時のみ表示） </label><br /></p>'. PHP_EOL;

	}

	function update( $new_instance, $old_instance ) { // title , alt , url , img , class , blank , top , bottom , start , end , memo , testmode

		$instance 				= $old_instance;
		$instance['title']      = strip_tags( $new_instance['title'] );
		$instance['alt']      	= strip_tags( $new_instance['alt'] );
		$instance['url']      	= $new_instance['url'];
		$instance['img']      	= $new_instance['img'];
		$instance['class']     	= $new_instance['class'];
		$instance['blank']      = $new_instance['blank'];
		$instance['top']		= (int) $new_instance['top'];
		$instance['bottom']		= (int) $new_instance['bottom'];
		$instance['start']     	= $new_instance['start'];
		$instance['end']     	= $new_instance['end'];
		$instance['memo']      	= strip_tags( $new_instance['memo'] );
		$instance['testmode']   = (bool) $new_instance['testmode'];

        return $instance;
	}
}

add_action('widgets_init', create_function('', 'return register_widget("ps_banner_with_date_widget");'));

